
from ASTRO import *
from basics import *

def getmapping(ref,mat,refm,matm,matched,nmax,xc,yc):
    rx = take(ref[1],matched[0]) - xc
    ry = take(ref[2],matched[0]) - yc
    mx = take(mat[1],matched[1]) - xc
    my = take(mat[2],matched[1]) - yc
    print extrema(mx), extrema(my)
    print extrema(rx), extrema(ry)
    u = concatenate([rx,ry])
    for nord in range(nmax+1):
      b = abasis(nord,mx,my,rot=1)
      sol = svdfit(b,u)
      u = add.reduce(sol*b,1)
      fx = u[:len(mx)]
      fy = u[len(mx):]
      print len(mx),sol
      print bwt(rx-fx), bwt(ry-fy)



