
from Numeric import *

def gauher(n,maxit=20,eps=3e-14):
   x = zeros((n,),Float)
   w = zeros((n,),Float)
   pim4 = pow(pi,-1./4)
   m = (n+1)/2
   for i in range(1,m+1):
      if i == 1: z = sqrt(2.*n+1) - 1.85575*pow(2.*n+1,-1./6)
      elif i == 2: z = z - 1.14 * pow(1.*n,0.426)/z
      elif i == 3: z = 1.86 * z - 0.86 * x[0]
      elif i == 4: z = 1.91 * z - 0.91 * x[1]
      else: z = 2. * z - x[i-3]
      for its in range(maxit):
        p1 = pim4
        p2 = 0.0
        for j in range(1,n+1):
           p3 = p2
           p2 = p1
           p1 = z*sqrt(2./j)*p2 - sqrt((j-1.0)/j)*p3
        pp = sqrt(2.*n)*p2
        z1 = z
        z = z1-p1/pp
        if abs(z-z1) <= eps: break
      x[i-1] = z
      x[n+1-i-1] = -z
      w[i-1] = 2./pow(pp,2)
      w[n+1-i-1] = 1.0*w[i-1]
   x,w = take([x,w],argsort(x),1)
   tw = w*exp(pow(x,2))
   return x,w,tw

